// implementation of class to read config file

#include <stdlib.h>
#include <stdio.h>
#include "RmsConfig.hh"

RmsConfig::RmsConfig( char* input_param_file_name,
		      char* output_param_file_name,
		      char* update_param_file_name ) 
{
  FILE* in;
  if ( (in=fopen(input_param_file_name,"r")) == NULL ) {
    printf("ERROR: cannot open %s.\n",input_param_file_name);
    exit(0);
  }
  
  fscanf(in,"%d",&number_of_channels);
  channel_names = new char* [number_of_channels];
  int i;
  for(i=0;i<number_of_channels;++i) {
    channel_names[i] = new char [ max_channame_length ];
    fscanf( in , "%s",channel_names[i] );
  }
  fscanf( in , "%d" , &secs_per_rms_reading );
  fscanf( in , "%s" , filter_filename );
  sprintf( output_filename,"%s",output_param_file_name );
  sprintf( input_filename,"%s",input_param_file_name );
  sprintf( update_filename,"%s",update_param_file_name );
  fclose(in);
}

int
RmsConfig::PrintChannelNames() {
  for(int i=0;i<number_of_channels;++i) {
    // KSG 9/17/05 The following printf changed by KSG
    //printf("%s\n",channel_names[i]);
    printf("DMT-BRMS_%s\n",channel_names[i]);
  }
  return 0;
}

RmsConfig::~RmsConfig()
{
  int i;
  for(i=0;i<number_of_channels;++i) {
    delete [] channel_names[i];
  }
  delete [] channel_names;
}
