/*----------------------------------------------------------------------*/
/*                                                         		*/
/* Module Name: LiveData						*/
/* Module Description: DAQSocket data wrapper				*/
/*                                                         		*/
/* Revision History:					   		*/
/* Rel   Date     Programmer  	Comments				*/
/* 0.1	 01Sep04  M. Evans   	First release				*/
/*                                                         		*/
/* see tdshead.hh for more information					*/
/*----------------------------------------------------------------------*/

#ifndef __LiveData_hh__
#define __LiveData_hh__

#include "DAQSocket.hh"

using namespace std;

//----------------------------------------------------------------------
// LiveData
//----------------------------------------------------------------------

struct LiveData
{
  DAQDChannel daq;				// DAQ channel
  int off;					// offset in raw data
  int len;					// data length
  double* data;					// latest data
  int seqNum;					// data sequence number
};

/* *********************** From DAQSocket.hh
struct DAQDChannel {
  char mName[50];	// The channel name
  int  mGroup;		// The channel group number
  int  mRate;		// The channel sample rate
  int  mNum;		// The channel or testpoint number
  int  mBPS;		// The channel bytes-per-sample value
  int  mDatatype;	// The channel data type
  float mGain;		// The channel front-end gain
  float mSlope;		// The channel slope
  float mOffset;	// The channel offset
  char mUnit[40];	// The channel unit
}; */

#endif // ifndef __LiveData_hh__
