#include <tid.h>
#include <TidString.h>

void TidBroadcast::SendEvent(Event* s) { // push event through IOserver
 
  TidString* msg = s->Marshal();

  /*
  static int nc = 0;
  nc++;
  cout<<nc<<endl;
  */

  Write(*msg); // write to data server

  delete msg; // delete string

}

TidBroadcast::TidBroadcast(const TidIO &org) : TidIO(org)
{
}


void TidBroadcast::SendTableofContent(Tid* t, int sock) { // send table of content

  char buf[512];
  TidString msg(t->GetsName());

  msg += "|";

  sprintf(buf,"%.10g|",t->GetTRes());
  msg += buf;

  sprintf(buf,"%.10g|",t->GetT0());
  msg += buf;

  list<ChnInfo*>::iterator p;

  for(p=t->GetDiagBegin(); p!=t->GetDiagEnd(); ++p) {
    msg += (*p)->GetName();
    msg += "|";
    sprintf(buf,"%u",(*p)->Getcid());
    msg += buf;
    msg += "|";
    sprintf(buf,"%u",(*p)->GetFs());
    msg += buf;
    msg += "|";
  }

  //  cout<<msg<<endl;

  Write(msg, sock);
}
